#include<string.h>
#include<stdlib.h>
#include"argon.h"

#include<unistd.h>
#include<time.h>

int main(int argc, char **argv)
{

	if(argc<3) {
		printf("Usage: %s <input file> <output file> [<coord output>]\n", argv[0]);
		exit(-1);
	}


	srand(time(NULL)%getpid()+20);

	char *fname_in=argv[1];
	char *fname_out=argv[2];
	char *fname_xyz=0;

	if(argc>=4) {
		fname_xyz=argv[3];
	}

	t_parameters pars;

	load_parameters(&pars, fname_in);

	t_state *state=alloc_state(pars.N);

	FILE *fout;

	if(strcmp(fname_out, "-")) {
		fout=fopen(fname_out,"w");
	} else {
		fout=stdout;
	}

	FILE *fxyz;

	if(fname_xyz) {
		fxyz=fopen(fname_xyz, "w");
		fprintf(fxyz, "%d\n", pars.N);
	} else {
		fxyz=0;
	}

	init_state(state, &pars);

	compute_forces(state, &pars);

	for(int i=0; i<pars.S_o; i++) {
		one_step(state, &pars);
	}

	double T_acc=0;
	double P_acc=0;
	double H_acc=0;

	for(int i=pars.S_o; i<pars.S_d+pars.S_o; i++) {
		one_step(state, &pars);

		T_acc+=state->T;
		P_acc+=state->P;
		H_acc+=state->H;

		if(i%pars.S_out==0) {
			save_state(fout, state);
		}
		if(i%pars.S_avs==0) {
			save_state_xyz(fxyz, state);
		}
	}

	T_acc/=pars.S_d;
	H_acc/=pars.S_d;
	P_acc/=pars.S_d;

	fprintf(fout, "%lf %lf %lf\n", T_acc, P_acc, H_acc);

	if(strcmp(fname_out, "-")) fclose(fout);
}
