#include<string.h>
#include<stdlib.h>
#include"argon.h"

#include<unistd.h>
#include<time.h>

#include"GL_helper.h"
#include<GL/glut.h>

#include<sys/time.h>

t_state *state;
t_parameters pars;

/*******************************************************************************
 Graphics main loop function.
*******************************************************************************/
void displayFunction(void)
{
	static int count=0;
    // Setup model transformations.
    glMatrixMode(GL_MODELVIEW); 
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    glPushMatrix();

    setupGraphicsState();

    // Draw the fixed sphere.
    float atomColor[4] = {.2, .8, .8, .8};
	float atomRadius=0.1;

	for(int i=0; i<state->N; i++) {
		drawSphere((double *)&(state->r[i]), atomColor, atomRadius);
	}

	glPopMatrix();
	glutSwapBuffers();                      
}

void redrawTimer(int msec) {
	one_step(state, &pars);
	glutTimerFunc(msec, redrawTimer, msec);
    glutPostRedisplay();
}

int main(int argc, char **argv)
{

	if(argc<2) {
		printf("Usage: %s <input file> \n", argv[0]);
		exit(-1);
	}

	srand(time(NULL)%getpid()+20);

	char *fname_in=argv[1];

	load_parameters(&pars, fname_in);

	state=alloc_state(pars.N);

	init_state(state, &pars);
	compute_forces(state, &pars);

    initGlut(argc, argv);
    glutDisplayFunc(displayFunction); 

	glutTimerFunc(10, redrawTimer, 10);

	glutMainLoop();
}
